﻿#include <iostream>
#include <vector>

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input
input_data() {
    Input in;
    size_t number_count;
    cin >> number_count;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        cin >> in.numbers[i];
    }
    size_t bin_count;
    cin >> in.bin_count;
    return in;
}

void
find_minmax(const vector<double>& numbers, double& min, double& max) {
    min = numbers[0];
    for (size_t i = 1; i < numbers.size(); i++) {
        if (numbers[i] < min) {
            min = numbers[i];
        }
        else if (numbers[i] > max) {
            max = numbers[i];
        }
    }
}

vector<size_t>
make_histogram(const vector <double>& numbers, size_t bin_count) {
    double minc, maxc;
    find_minmax(numbers, minc, maxc);
    vector<size_t> bins(bin_count);
    double bin_size = (maxc - minc) / bin_count;
    size_t bin_max_size = 0;
    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = minc + j * bin_size;
            auto hi = minc + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
                if (bins[j] > bin_max_size) {
                    bin_max_size = bins[j];
                }
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
            if (bins[bin_count - 1] > bin_max_size) {
                bin_max_size = bins[bin_count - 1];
            }
        }
    }
    return bins;
}

void
show_histogram_text(vector<size_t> bins) {
    size_t bin_max_size = 0;
    for (auto bin : bins) {
        if (bin_max_size < bin) {
            bin_max_size = bin;
        }
    }
    double k = double(MAX_ASTERISK) / bin_max_size;
    if (k > 1) {
        k = 1;
    }
    for (size_t bin = 0; bin < bins.size(); bin++) {
        if (bins[bin] < 100) {
            cout << " ";
        }
        if (bins[bin] < 10) {
            cout << " ";
        }
        cout << bins[bin] << "|";
        for (size_t i = 0; i < bins[bin] * k; i++) {
            cout << "*";
        }
        cout << endl;
    }
}

int main() {
    Input in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins);
    return 0;
}